'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _weakMap = require('babel-runtime/core-js/weak-map');

var _weakMap2 = _interopRequireDefault(_weakMap);

var _ConfigCommandTypes = require('./ConfigCommandTypes');

var _ConfigCommandTypes2 = _interopRequireDefault(_ConfigCommandTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @private
 * @type {WeakMap}
 */
var CONTAINER = new _weakMap2.default();

/**
 * @class
 */

var ConfigCommandFactory = function () {
  /**
   * @constructor
   * @param {ConfigContainer} container
   */
  function ConfigCommandFactory(container) {
    (0, _classCallCheck3.default)(this, ConfigCommandFactory);

    CONTAINER.set(this, container);
  }

  /**
   * @readonly
   * @type {ConfigContainer}
   */


  (0, _createClass3.default)(ConfigCommandFactory, [{
    key: 'createCommand',


    /**
     * Creates {@link ConfigCommand}
     * @param {String} name
     * @returns {ConfigCommand}
     */
    value: function createCommand(name) {
      return this.container.resolve(_ConfigCommandTypes2.default[name]);
    }
  }, {
    key: 'container',
    get: function get() {
      return CONTAINER.get(this);
    }
  }]);
  return ConfigCommandFactory;
}();

exports.default = ConfigCommandFactory;
module.exports = exports['default'];
//# sourceMappingURL=ConfigCommandFactory.js.map