'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _iterator = require('babel-runtime/core-js/symbol/iterator');

var _iterator2 = _interopRequireDefault(_iterator);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _weakMap = require('babel-runtime/core-js/weak-map');

var _weakMap2 = _interopRequireDefault(_weakMap);

var _ConfigDependencyIterator = require('./ConfigDependencyIterator');

var _ConfigDependencyIterator2 = _interopRequireDefault(_ConfigDependencyIterator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @private
 * @type {WeakMap}
 */
var ROOT = new _weakMap2.default();

/**
 * @private
 * @type {WeakMap}
 */
var CHILDREN = new _weakMap2.default();

/**
 * Supports {@link https://developer.mozilla.org/en/docs/Web/JavaScript/Reference/Iteration_protocols|iteration protocols} via {@link ConfigDependencyIterator}
 * @class
 */

var ConfigDependency = function () {
  /**
   * @constructor
   * @param {Config} root
   * @param {ConfigDependency[]} children
   */
  function ConfigDependency(root) {
    var children = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    (0, _classCallCheck3.default)(this, ConfigDependency);

    ROOT.set(this, root);
    CHILDREN.set(this, children);
  }

  /**
   * @readonly
   * @type {Config}
   */


  (0, _createClass3.default)(ConfigDependency, [{
    key: _iterator2.default,


    /**
     * @returns {ConfigDependencyIterator}
     */
    value: function value() {
      return new _ConfigDependencyIterator2.default(this);
    }
  }, {
    key: 'root',
    get: function get() {
      return ROOT.get(this);
    }

    /**
     * @readonly
     * @type {ConfigDependency[]}
     */

  }, {
    key: 'children',
    get: function get() {
      return CHILDREN.get(this);
    }
  }]);
  return ConfigDependency;
}();

exports.default = ConfigDependency;
module.exports = exports['default'];
//# sourceMappingURL=ConfigDependency.js.map